#!/bin/sh

COUNTER=0
num=5

#########################
# The command line help #
#########################
display_help() {
        echo "Usage: $0 <SPI_flash_image_binary>" >&2
        echo
        exit 1
}

# Check if image file is defined
if [ -z "$1" ]
then
	echo "### No Image file defined ###"
	echo
	display_help
fi

# Check if image file exists
if [ ! -e $2 ]
then
	echo "### Image file doesn't exist ###"
	echo
	display_help
fi

#Rescan spi_nor module for mtd
sleep 0.1
echo "spi1.0" > /sys/module/spi_nor/parameters/rescan 
sleep 0.1
num=`cat /proc/mtd |grep "Aspen" | sed 's/:.*//' | sed "s/[^0-9]//g" | sed "s/[^0-9]//g"`

while [  ! -e /dev/mtd$num ] && [ $COUNTER -lt 10 ]; do
        echo The counter is $COUNTER
        #ls -la /dev/mtd*
        sleep 1
        let COUNTER=COUNTER+1
done

if [ -e /dev/mtd$num ]
then
	sleep 0.3
	cat /proc/mtd
        echo "Programming Flash `cat  /sys/module/it_fpga/parameters/cpu_to_spiFlash_connect` (mtd$num) ... "
        #Write image to offset 0x10000                                                                       
        dd if=$2 of=/dev/mtd$num bs=512 seek=128                                                             
        #Write version to flash                                                                              
        md5=($(md5sum $2))                                                                                   
        echo "md5: $md5"                                                                                     
        echo "$md5" > /tmp/versionRead$1.bin                                                                 
        dd if=/tmp/versionRead$1.bin of=/dev/mtd$num bs=1 seek=0 count=33
	echo "spi1.0" > /sys/module/spi_nor/parameters/remove	
        echo "DONE" 
else
	echo "#### ERROR - Programming not started ####"
fi

